static char *cvs_id =" $Id: xnd_cal.c,v 1.2 2002/01/10 15:24:41 berar Exp $ ";
/* XND_CAL  Calcul Theta hkl ... */

#define  USE_RPRO
#define  USE_BRAGG
#define  USE_VAR
#define  USE_SCAN
#define  USE_EXPER
#define  USE_PENAL
#define  USE_PHASE
#define  USE_PSEUDO
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "../xnd_mem.h"

#ifndef _INCLUDE_HPUX_SOURCE
#include <time.h>
/* required for rand init */
#endif

#include <string.h>
/* ----------------------------------------------------------- */
TYPE_RPRO *l_indic ;
/* ----------------------------------------------------------- */
typedef struct
{  char  semi;
   char format[10];
   int   accuracy;
   } TYPE_PLG;
void plg_header( TYPE_PLG *plg_info);
void plg_printf( TYPE_PLG *plg_info, int pos, float d, float a);
void plg_addend( TYPE_PLG *plg_info);
/* ----------------------------------------------------------- */
static int search_first ( P_(FLOAT) valeur)
#ifdef NO_PROTO
float valeur;
#endif
{   int  act=0;
    int  sup=n_pts;
    int  inf=0;
    int  dif;
    FLOAT *l_pt;
    l_pt = l_points;
    while (sup!=inf)
    {    act += (dif = (sup+inf-1)/2 - act);
	 l_pt += dif;
	 if ( valeur >= *l_pt )
	     inf = act+1;
	 else sup = act;
	 }
    l_points = l_pt;
    return (sup);
    }

/* ----------------------------------------------------------- */
static int profil_hkl (P_(void))
{   float fin,debut;
    int   nombre=0;
    int   pos;

   fin = DTH + influence;
   if (fin>diag_pn) fin= diag_pn;
   debut = DTH - influence;
   if (debut<diag_p0) debut = diag_p0;
   l_points = l_diag->points;
   pos = first_point = search_first (DTH);
   if (first_point < n_pts)
   {  l_points = &l_diag->points[pos];
	   while ((pos<n_pts) && (profil_point (pos) || *l_points<=fin))
	   {  l_points++;
		   nombre++;
		   pos++;
         }
	   act->fin = (pos == n_pts) ? pos-1 : pos;
	   pos = first_point - 1;
      l_points = &l_diag->points[pos];
 	   while (( pos >= 0 )&& (profil_point (pos)|| *l_points>=debut))
	   {  l_points--;
		   nombre++;
		   pos--;
	      }
	  act->deb = (pos < 0) ? 0 : pos;
     }
  return(nombre);
  }
/* ----------------------------------------------------------- */
void traite_hkl(P_(void))
{  int vu = 2;
   push_err_msg("traite_hkl(xnd_cal.c)");
   n_bragg++;
   if (def_profil())
   {  if (ini_profil() != 0)
	   {  if (fini==0) ini_d_metric ();
	     vu = 1;
	     if (profil_hkl() != 0)
	     {   m_bragg++;
	         vu = 0;
		 if ( /* fini && */ bragg_fich != NULL)
		     fwrite (act, bragg_size, 1, bragg_fich);
		  }
	      } 
	 if (fini && prt_hkl & 6 && vu)  fprintf (list_fich,
             "   (%d)%3d%3d%3d (%d) %7.3f %6.1f (%6.1f %6.1f) %s\n",
	     act->phase,H,K,L,act->lambda,DTH,I_C,F_A,F_B,
	     vu==2?"negligeable":"non visible");
	 }
    else fprintf (list_fich,
 " --- (%d)%3d%3d%3d (%d) %6.3f %2d %7.2f %7.2f %6.0f (%5.1g %5.1g) %5.3f sqrt(%5.3f) non positive width\n",
	 act->phase,H,K,L,act->lambda,DTH,act->mu,act->cor,
	 act->orien,I_C,F_A,F_B,W_G,act->w_lorentz);
    pop_err_msg();
    }

/* ----------------------------------------------------------- */
void residu(P_(void))
{    int i,j,jj;
     float w,v,d,a,dd,sw;
     float i_obs,back,val,val_b;
     float z;
     float ex_dd = 0;
     float ex_d = 0;
     float ex_a = 0;
     float max_d,max_dt;
     float max_dd = 0;
     float zl = 0;
     float nz = 1;
     float uz;
     float mod_y=0;
     float *mod_m;
     int   add_lin = 0;
     int   signe;
     int   not_bg;
     int   lsq_correl = mod_lsq & 4;
     int   vraisemb = mod_lsq & 2;
     int   lsq_bkg = mod_lsq & 8;
     int   genere;
     TYPE_PLG plg_info;
#if defined ( __STDC__ ) || defined ( THINK_C )
     time_t t_srand;
#else
     long   t_srand;
#endif

     push_err_msg("residu xnd_cal.c)");
     if (do_plg_data) plg_header (&plg_info);
       else if (lsq_correl) mod_m = (float *) tst_alloc (n_par,sizeof(float),"mod_lsq");
     if (/* cycle == 0  && */ l_exper->dfich == 0)
     {  genere = 1;
        srand((unsigned) time (&t_srand));
	} else genere = 0;

     for (i=0,l_points=l_diag->points;i<n_pts;i++,l_points++)
     {   val_b = get_ical(i);
	 not_bg = val_b > minimum;
	 val = val_b + (back = get_ibkg(i));
         /* bruit approx Poisson, i_obs si pas de exper */
#define MAX_POISSON   70
	 if (genere)
	 {   if  (val <= 0) i_obs = 0;
	     else
	     {   a = val < MAX_POISSON ? val : MAX_POISSON;
	         d = fsrand() * exp (a);
	         i_obs = 0; dd = z = 1;
	         while (dd < d)
	         {    i_obs += 1; z *= a/i_obs;  dd += z; }
	         if (val > MAX_POISSON )
	         {    i_obs += (d - dd) / ( d /( a * (i_obs-1)) - dd);
	              i_obs = (i_obs - MAX_POISSON) * sqrt (val / MAX_POISSON);
	              i_obs = floor (val + i_obs);
	          }   }
	      if (i_obs > 0) w = 1 / i_obs;  else w = 1;
	      put_iobs(i, i_obs); 
			put_wght(i, w);    /* used by R_Bragg */
	      }
	 else 
      {   i_obs = get_iobs(i);
	     if ( vraisemb )
	     {   if (val > 0) w = 1 / val;  else w = 1;
			       put_wght(w, i);    /* used by R_Bragg */
                }
             else w=get_wght(i); 
	     }
	 sw = sqrt (w);
	 d = i_obs  - val;
	 a = sw * d;
	 l_indic->so_wp += i_obs * i_obs * w;
	 l_indic->sd_wp += dd = d*d * w;
	 l_indic->so_p  += i_obs;
	 l_indic->sd_p  +=  d>=0 ? d :-d;
	 if (not_bg)
	 {   l_indic->so_wp_b += sqr(i_obs - back) * w;
	     l_indic->sd_wp_b += d*d * w;
	     l_indic->so_p_b  += i_obs-back;
	     l_indic->sd_p_b  +=  d>=0 ? d :-d;
	     l_indic->s_n_b += 1;
             }
	 if (i!=0) l_indic->d_val += (a-ex_a)*(a-ex_a);
	 ex_a = a;
         /* to know the worst point  */
	 if (dd > max_dd)
	 {   max_d = d;
		 max_dd = dd;
		 max_dt = *l_points;
		 }
         /* calculation for serial correlations indicator */
	 signe = d * ex_d > 0;
	 if (signe)
	 {   uz = dd + ex_dd;
/* modification 20/11/91 car sinon incorrect en l'absence de correlation */
         z = uz * sqrt (2*M_PI * ( uz));
	     z /= (2 + 2 * uz + z);
	     zl +=  z * a;
	     add_lin++;
	     }
	 else
	 {   if (add_lin) l_indic->sd_wp_cor += zl*zl;
	     z = zl = 0;
	     }
	 nz = 1 - z * z;
	 l_indic->sd_wp_cor += nz * dd;

	 if (do_plg_data) plg_printf( &plg_info, i, d ,a);
	 else if (!lsq_bkg || not_bg)
	 {    uz = lsq_correl ==0 ? 1 : nz;
	      for (j=0;j<n_par;j++)
		 if((v=uz*w*get_dydp(i,j+1))!=0.0)
	      {    y_vect[j] += d * v;
		   for (jj=0;jj<=j;jj++) matrice[(j*(j+1))/2+jj]
			 += v * get_dydp(i,jj+1);
		   }
	      if (lsq_correl)
	      /* le terme de ponderation non-diagonal */
	      {    if ( signe )
			{    mod_y += z * a;
			for (j=0;j<n_par;j++)
			  if((v=get_dydp(i,j+1))!=0.0)
			   mod_m[j] += z * sw * v;
			}
		   else
		   {   if (add_lin)
		       for (j=0;j<n_par;j++)
		       {    y_vect[j] += mod_y * mod_m[j];
			    for (jj=0;jj<=j;jj++) matrice[(j*(j+1))/2+jj]
			      += mod_m[jj] * mod_m[j];
			    }
		    }  }
	      }
	 if (!signe && add_lin)
	 {    add_lin = 0;
	      if (lsq_correl) for (j=0;j<n_par;j++) mod_m[j] = 0;
	      }
	 ex_d = d;
	 ex_dd = dd;
	 }
	 if (do_plg_data) plg_addend( &plg_info);
    else if (lsq_correl) free (mod_m);
    l_indic->s_n = n_pts;
    if (minli==0)
    {   l_indic->s_n = n_pts;
	if (nt_diag>1)  fprt_indic(l_indic,0);
	if (n_pts * max_dd > 5 * l_indic->sd_wp)
   fprintf (list_fich,"\n Erreur maximale a %.3f : %.1f, %+.1f sigma, %.4f R\n",
		  max_dt,max_d,sqrt(max_dd),max_dd/l_indic->sd_wp);
     }  
     pop_err_msg();
     }

/* ----------------------------------------------------------- */
/* calcul echelle : exp(a) / (exp(a)+exp(-a)) = 1/(1+exp(-2a)  */
/* avec  a = signe(t-to) * dt * abs(t-to)^t_ex                 */
/* deriv est divise par sa valeur cf son usage */
float f_echelle(P_(int) i, P_(float *) d)
#ifdef NO_PROTO
int i;
float *d;
#endif
{   int j; 	
	 float to,dt,ex,tex;
	float u,a,b,c,rt,et;
	float *deriv;

	j = i;
	deriv = d + l_phase->ech->dim + j;
	*deriv = *(deriv+1) = *(deriv+2) = 0;
	var_init(l_phase->transit);
	to = var_valeur (j);
	dt = var_valeur (1+j);
	ex = var_valeur (2+j);
        u = (l_diag->temp - to);
	if (u < 0 )  { a = -1;  u = -u; } else a=1;
        b = a * dt;
	if ( u > EPSILON )
	{   tex = -2 * b * ( c = pow(u,ex));
		if (tex < LN_MAXFLOAT)
		{   rt = ( 1 / ( 1 + (et = exp (tex))));
			et *=  2*rt;        /* rt^2/rt cf usage */
			*deriv =  -et * b * ex * c / u;
			*(deriv+1) = et * a * c;
			*(deriv+2) = et * b * c * log(u);
			return (rt);
			}
		return (0);
		}
	return (0.5);
	}
/* ----------------------------------------------------------- */
void plg_header( TYPE_PLG * plg_info)
{  int i;
   plg_info->semi = ( prt_plg & PLG_ADDSEMI) ? ';' : ' ';
   plg_info->accuracy = 2;
   if ( l_diag->w_mini > MINFLOAT ) plg_info->accuracy = 2 - floor(log10(l_diag->w_mini));
   if ( plg_info->accuracy < 2) plg_info->accuracy = 2;
   sprintf (plg_info->format," %%8.%df%c",
      plg_info->accuracy, plg_info->semi);
   if (prt_plg && !(prt_plg & PLG_NHEADER) ) 
	{   fprintf (plg_fich,
	"# %s\n# %f\n#  2theta    Yobs      Ycal      Ybkg       dY    dY/sY",
        l_exper->nom, l_diag->temp);
		 for (i=0; i<tot_phase; i++) fprintf(plg_fich, " %8d ", i);
		 fprintf(plg_fich, "\n");
		 }	
	 }
/* ----------------------------------------------------------- */
void plg_printf( TYPE_PLG * plg_info, int pos, float d, float a)
{   int i;
    float x;
    float b = get_ibkg(pos);
    x = !(prt_plg & PLG_QSTEP) ? *l_points : (4 * M_PI )* sin(*l_points * RAD/2) / lambda;
    fprintf (plg_fich, " %8.4f%c", x, plg_info->semi);
	 fprintf (plg_fich, plg_info->format, get_iobs(pos));
    fprintf (plg_fich, plg_info->format, b + get_ical(pos));
    fprintf (plg_fich, plg_info->format, b);
    fprintf (plg_fich, " %7.*f%c", plg_info->accuracy, d, plg_info->semi);
    fprintf (plg_fich, " %5.1f%c", a, plg_info->semi);
	 for (i=0; i<=tot_phase; i++)
       fprintf (plg_fich, plg_info->format, get_ipha(pos, i));
    fprintf(plg_fich,"\n");
    }
/* ----------------------------------------------------------- */
void plg_addend( TYPE_PLG * plg_info)
{   if (prt_plg & PLG_ADDEND)
{  fprintf (plg_fich, " %8.4f%c", 999.999, plg_info->semi);
    fprintf (plg_fich, plg_info->format, 999);
    fprintf (plg_fich, plg_info->format, 999);
    fprintf(plg_fich,"\n");
    }
    }
/* ----------------------------------------------------------- */

