static char *cvs_id =" $Id: xnd_moco.c,v 1.2 2002/01/10 15:24:42 berar Exp $ ";
/* XND_MOCO.C           procedures specific    */
/*  for MOdulated COmposites (incomensurate)   */
/*  initialisation, loop on indices            */
/*  --------------------------------           */

#define  USE_BRAGG
#define USE_VAR
#define USE_SETS
#define USE_SYM
#define USE_MODUL
#define USE_PHASE
#define USE_ATOM
#define USE_PSEUDO

#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "xnd_moh.h"
#include "../use/xnd_nrh.h"

#include <string.h>
#include <ctype.h>
/* ---------------------------------------------------------- */
static void genget_moco  PROTO((void));
static int compo_mult PROTO((void));
/* -------------------------------------------------- */
/* tables used in fhkl_atom functions */
static float  *x_modul=NULL; 
/* -------------------------------------------------- */
/* the structure factor procedure is the same for     */   
/* composites and ordinary incomensurates             */
/*                fhkl_incmod                         */
/* composites dependence are take into account in it  */
/* -------------------------------------------------- */


/* ---------------------------------------------------------- */
/* prepare internal structure during phases initialisation    */
/* make a twin symgrp for the second cell                     */
/* ---------------------------------------------------------- */
static int ini_moco_loop(P_(TYPE_PSEUDO *) l_pseudo_phase);
int ini_composite(P_(TYPE_PSEUDO *) local_pseudo)
#ifdef NO_PROTO
TYPE_PSEUDO * local_pseudo;
#endif
{   float  *l_coef, *l_coef4, *o_coef, *o_coef4;
    TYPE_SYMGRP *l_sym, *l_sym4, *o_epsilon;
    int   i, j, size, size4, nops, isat;
    int err = 0;
    push_err_msg("ini_composite (xnd_moco.c");
    local_pseudo->genget_hkl = genget_moco;
    local_pseudo->basic_mult = local_pseudo->multiplicity;
    if (l_pseudo_phase->sets->nb_hkl<=0) err = ini_moco_loop(local_pseudo);
	 else if (local_pseudo->sets->loop_str == NULL || *local_pseudo->sets->loop_str==0 )
       fprintf(list_fich," @SET::LINES=%d>0 skiping @SET::LOOP='%s'\n",
         local_pseudo->sets->nb_hkl, local_pseudo->sets->loop_str); 
    current_symgrp = l_phase->symgrp;
    current_modul = l_phase->modul;
   pop_err_msg();
   return err;
   }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
static int loop_label_00(TYPE_PSEUDO * l_pseudo_phase)
{   l_pseudo_phase->sets->loop_str=str_alloc("HK,L=0,M=0");
    l_pseudo_phase->satel=(TYPE_SATEL *) tst_alloc(1,sizeof(TYPE_SATEL),"sattelite");
    l_pseudo_phase->satel->n_ind=1;
    l_pseudo_phase->satel->hkl_sat[0]=0;
    if (l_pseudo_phase->sets->nb_hkl == 0) l_pseudo_phase->sets->nb_hkl=-1;
    fprintf(list_fich," common lines according @SET(LOOP)='%s'\n",
       l_pseudo_phase->sets->loop_str);
    return 0;
    }
static int loop_label_0m(TYPE_PSEUDO * l_pseudo_phase)
{   l_pseudo_phase->sets->loop_str=str_alloc("HK,L=0,M");
    l_pseudo_phase->satel=(TYPE_SATEL *) tst_alloc(1,sizeof(TYPE_SATEL),"sattelite");
    l_pseudo_phase->satel->n_ind=1;
    l_pseudo_phase->satel->hkl_sat[0]=0;   /* dummy */
	 l_pseudo_phase->multiplicity=compo_mult;
    if (l_pseudo_phase->sets->nb_hkl == 0) l_pseudo_phase->sets->nb_hkl=-3;
    fprintf(list_fich," 2nd layer lines according @SET(LOOP)='%s'\n",
      l_pseudo_phase->sets->loop_str);
    return 0;
    }
static int loop_label_l0(TYPE_PSEUDO * l_pseudo_phase)
{   l_pseudo_phase->sets->loop_str=str_alloc("HKL,M=0");
    l_pseudo_phase->satel=(TYPE_SATEL *) tst_alloc(1,sizeof(TYPE_SATEL),"sattelite");
    l_pseudo_phase->satel->n_ind=1;
    l_pseudo_phase->satel->hkl_sat[0]=0;
    if (l_pseudo_phase->sets->nb_hkl == 0) l_pseudo_phase->sets->nb_hkl=-2;
    fprintf(list_fich," first layer lines according @SET(LOOP)='%s'\n",
      l_pseudo_phase->sets->loop_str);
    return 0;
    }
static int error_label(TYPE_PSEUDO * l_pseudo_phase, char *m )
{   verbose_printf("error '%s'\n  invalid string for composites in @SET(LOOP)='%s'\n",
      m, l_pseudo_phase->sets->loop_str);
    return 1;
    }

static int ini_moco_loop(P_(TYPE_PSEUDO *) l_pseudo_phase)
{  TYPE_SATEL * l_satel;
   char copy[50];
   char *loop_str, *c, *e;
   int i, n;
   short m[21];
   current_sets = l_pseudo_phase->sets;
	loop_str = current_sets->loop_str;
   if (loop_str == NULL || *loop_str==0 )
	   return error_label(l_pseudo_phase,
	       "No @SET(LOOP) or empty one, reqested : no default for composite'\n");
   c = strcpy(copy, loop_str);
   while ( *c==' '||*c==','||*c=='H'||*c=='K' ) c++;
   if ( *c=='0' )   /* HK00 , HK0M , HK0M=0 */
	{  c++;
	   while ( *c==' '||*c==',' ) c++;
	   if ( *c =='0')  /* HK00 */
		{    free(loop_str);
		     return loop_label_00(l_pseudo_phase); 
			  }
		if (*c == 'M')
		{ 	 c++;
		    while ( *c==' '||*c=='=' ) c++;
	       if ( *c =='0')  /* HK00 */
		    {   free(loop_str);
		        return loop_label_00(l_pseudo_phase); 
			     }
	       if (*c == 0)  /* HK0M */
		    {   free(loop_str);
		        return loop_label_0m(l_pseudo_phase); 
			     }
	       if (isdigit(*c)) return error_label( l_pseudo_phase, "HK0?" );
		 }	 }
   if ( *c=='L' )  
	{  c++;
	   while ( *c==' ' ) c++;
		if (*c == '=')  /* HKL=x,M */
		{ 	 c++;
		    while ( *c==' ') c++;
	       if ( *c !='0') return error_label(l_pseudo_phase, "HKL? not zero" ); 
		    c++;
		    while ( *c==' '|| *c==',' ) c++;
	       if ( *c =='0')  /* HK00 */
		    {   free(loop_str);
		        return loop_label_00(l_pseudo_phase); 
			     }
	       if (*c == 0)  return error_label(l_pseudo_phase, "HKL? empty" );  
		    if (*c == 'M')
		    {   c++;
		        while ( *c==' ' ) c++;
	           if (*c == 0)  /* HK0M */
		        {   free(loop_str);
		            return loop_label_0m(l_pseudo_phase); 
			         }
		        if ( *c !='=')  return error_label(l_pseudo_phase, "HKLM? not =" );
				  c++;
		        while ( *c==' ' ) c++;
	           if (*c == '0')  /* HK00 */
		        {   free(loop_str);
		            return loop_label_00(l_pseudo_phase); 
			     }
			  }
		  return error_label( l_pseudo_phase,"HK? 0 or L expected" ); 
		  }   /* end HKL=x,M */
	   while ( *c==' '|| *c==',' ) c++;
	   if (*c == '0')  /* HKL0 */
		{   free(loop_str);
		    return loop_label_l0(l_pseudo_phase); 
			 }
      if ( *c!='M' ) return error_label(l_pseudo_phase, "HKL? not M" ); 
		c++;
		while ( *c==' ') c++;
		if ( *c !='=')  return error_label(l_pseudo_phase, "HKLM? not ="  );
		c++;
      n = 0;
      e = strtok(c, ",");
      while ( e && *e != 0 )
	   {  if (sscanf(e," %hd",m+n) != 1 ) return error_label(l_pseudo_phase, "HKLM= num expected"  );
         n++;
	      e = strtok(NULL, ",");
         if ( n>=21) return error_label(l_pseudo_phase, "HKLM=i,j... too much values in one set"  );
			}
     if (n==0) return error_label( l_pseudo_phase, "HKL? not M"  );
	  if (n==1 && m[0]==0) return loop_label_l0(l_pseudo_phase); 
/*	  if (n==1 && m==0) return loop_label_l0(l_pseudo_phase); error! DG nov 2001*/
     l_pseudo_phase->satel=l_satel=(TYPE_SATEL *)
     tst_alloc(1,sizeof(TYPE_SATEL)+(n-1)*sizeof(short),"sattelite");
     l_satel->n_ind=n;
     for (i=0;i<n;i++) l_satel->hkl_sat[i]=m[i];
     fprintf(list_fich," %d sattelite(s) ( ", n);
     for (i=0;i<n;i++) fprintf(list_fich," %d ", l_satel->hkl_sat[i]);
   	fprintf(list_fich," ) according @SET(LOOP)='%s'\n", l_pseudo_phase->sets->loop_str);
      return 0;
	  }
   return error_label( l_pseudo_phase,"unexpected case" );
   }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
static void moco_gen_00 (P_(void))
{  int k_min, h_max, k_max, l_max;
   int my_l;
   push_err_msg("moco_gen_00(xnd_moco.c)");
   h_max = 2 * (1+sqrt( q_max / g_aa ));
   k_max = 2 * (1+sqrt( q_max / g_bb ));
	for (H=0;H<=h_max;H++)
   {  k_min = 0;
	   if ( H && (systeme=='N' || systeme=='A')) k_min = - k_max;
      for (K=k_min;K<=k_max;K++)
      if ( H != 0 || K != 0)
		{  L = 0;
			if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
         if (systeme=='T')
         {  if (K!=0 || L!=0)
            {  H = -H;
               if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
               H = -H;
               }
             if (K!=0 && K!=H && L!=0)
                {  K = -K;
                   if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                   K = -K;
                   }
                if (L!=0 && L!=K)
                {  L = -L;
                   if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                   L = -L;
                   } 
					} /* systeme  T */
            if (systeme=='R' && (L!=0 && ( H!=0 || K!=0) ))
            {  L = -L;
               if (exist_hkl(0) && !current_symgrp->holoedre)
               gen_holoedre ();
               L = -L;
               }
         }    /* for K */
      }  /* for H */
   pop_err_msg();
   }
/* ---------------------------------------------------------- */
static void moco_gen_l0 (P_(void))
{  int h_min, k_min, h_max, k_max, l_max;
   push_err_msg("gen_moco(xnd_moco.c)");
   h_max = 2 * (1+sqrt( q_max / g_aa ));
   k_max = 2 * (1+sqrt( q_max / g_bb ));
	l_max = 2 * (1+sqrt(q_max /g_cc));
	h_min = 0;
	if (systeme=='M' || systeme=='A') h_min = - h_max;
	for (H=h_min;H<=h_max;H++)
   {  k_min = 0;
      if (H && (systeme=='N' || systeme=='A') ) k_min = - k_max;
	   for (K=k_min;K<=k_max;K++)
      {  for (L=1; L<=l_max; L++)
			{  if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
            if (systeme=='T')
            {  if (K!=0 || L!=0)
               {  H = -H;
                  if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                  H = -H;
                  }
                if (K!=0 && K!=H && L!=0)
                {  K = -K;
                   if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                   K = -K;
                   }
                if (L!=0 && L!=K)
                {  L = -L;
                   if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                   L = -L;
                   } 
					} /* systeme  T */
            if (systeme=='R' && (L!=0 && ( H!=0 || K!=0) ))
            {  L = -L;
               if (exist_hkl(0) && !current_symgrp->holoedre)
               gen_holoedre ();
               L = -L;
               }
            }   /* for my_l */
         }    /* for K */
      }  /* for H */
   pop_err_msg();
   }
/* ---------------------------------------------------------- */
static void moco_gen_0m (P_(void))
{  int h_min, k_min, h_max, k_max, m_max, M;
   float v;
   push_err_msg("gen_moco(xnd_moco.c)");
   h_max = 2 * (1+sqrt( q_max / g_aa ));
   k_max = 2 * (1+sqrt( q_max / g_bb ));
	h_min = 0;
	if (systeme=='M' || systeme=='A') h_min = - h_max;
   var_init(l_phase->vector);
   v=var_valeur(2);
	m_max = 2 * (1+sqrt( q_max *v / g_cc));
	for (H=h_min;H<=h_max;H++)
   {  k_min = 0;
	   if ( H && (systeme=='N' || systeme=='A')) k_min = - k_max;
	   for (K=k_min;K<=k_max;K++)
      {  L=0;
		   for (M=1; M<=m_max; M++)
			{  act->h[3] = M;
		      if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
            if (systeme=='T')
            {  if (K!=0 || M!=0)
               {  H = -H;
                  if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                  H = -H;
                  }
                if (K!=0 && K!=H && M!=0)
                {  K = -K;
                   if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                   K = -K;
                   }
                if (M!=0 && M!=K)
                {  M = -M;
                   if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                   M = -M;
                   } 
					} /* systeme  T */
            if (systeme=='R' && (M!=0 && ( H!=0 || K!=0) ))
            {  M = -M;
               if (exist_hkl(0) && !current_symgrp->holoedre)
               gen_holoedre ();
               M = -M;
               }
            }   /* for my_l */
         }    /* for K */
      }  /* for H */
   pop_err_msg();
   }
/* ---------------------------------------------------------- */
static void moco_gen_lm (P_(void))
{  int h_min, k_min, h_max, k_max, l_max;
   push_err_msg("gen_moco(xnd_moco.c)");
   h_max = 2 * (1+sqrt( q_max / g_aa ));
   k_max = 2 * (1+sqrt( q_max / g_bb ));
	l_max = 4 * (1+sqrt(q_max /g_cc));
	h_min = k_min = 0;
	if (systeme=='M' || systeme=='A') h_min = - h_max;
	if (systeme=='N' || systeme=='A') k_min = - k_max;
	for (H=h_min;H<=h_max;H++)
   {  for (K=k_min;K<=k_max;K++)
      {  for (L=1; L<=l_max; L++)
			{  if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
            if (systeme=='T')
            {  if (K!=0 || L!=0)
               {  H = -H;
                  if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                  H = -H;
                  }
                if (K!=0 && K!=H && L!=0)
                {  K = -K;
                   if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                   K = -K;
                   }
                if (L!=0 && L!=K)
                {  L = -L;
                   if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
                   L = -L;
                   } 
					} /* systeme  T */
            if (systeme=='R' && (L!=0 && ( H!=0 || K!=0) ))
            {  L = -L;
               if (exist_hkl(0) && !current_symgrp->holoedre)
               gen_holoedre ();
               L = -L;
               }
            }   /* for my_l */
         }    /* for K */
      }  /* for H */
   pop_err_msg();
   }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
static void genget_moco (P_(void))
{   int i, j, n;
    push_err_msg("genget_moco(xnd_mod.c)");
    current_modul = l_pseudo_phase->modul;
    current_satel = l_pseudo_phase->satel;
    current_sets  = l_pseudo_phase->sets;
    vector_deriv = NULL;
    if  (l_phase&&l_phase->vector->dim >=1)
          vector_deriv = (float *) tst_alloc (3 * current_modul->size,
              sizeof(float), "derivatives of vector");
    alloc_incmod();
    fflush (list_fich);

    if (current_sets->nb_hkl > 0) get_hkl();
    else for (i=0,j=0; i<current_satel->n_ind;i++)
    {   for (n=0; n<current_modul->size;n++,j++) 
	         act->h[3+n]=current_satel->hkl_sat[j];
			switch (current_sets->nb_hkl)
		   { case  0 : moco_gen_lm(); break;
		     case -1 : moco_gen_00(); break;
		     case -2 : moco_gen_l0(); break;
		     case -3 : moco_gen_0m(); break;
		     default : tst_abort(1, "internal error : current_sets->nb_hkl=%d",current_sets->nb_hkl);
           }
       }
    free_incmod();
    if (vector_deriv) free (vector_deriv);
    pop_err_msg();
    }
/* ---------------------------------------------------------- */
static int compo_mult(P_(void))
{   int m, mult;
    m = L;
	 L = act->h[3];
	 mult = (*(l_pseudo_phase->basic_mult))();
	 L = m;
	 return mult;
    }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */

