static char *cvs_id =" $Id: xnd_vio.c,v 1.3 2002/05/02 12:43:28 berar Exp $ ";
/* xnd_vio.c      variables input and output */

#define USE_SETS
#define USE_VAR
#define USE_KEYS
#define USE_PHASE
#define USE_PENAL
#include "../xnd_def.h"
 
#include "../read/xnd_rdh.h"   /* lect->max_order */
extern FILE * coord_fich;
/* -------------------------------------------------------------------- */
#include <string.h>
#include <ctype.h>
/* -------------------------------------------------------------------- */
static void var_realloc_table(TYPE_VAR *var, int old);
static int *mode_codes;
static int  var_position;
static int  var_mode_mask;
static int  do_print;
/* ------------------------------------------------------------------ */
void  var_init_loop (P_(int) saving, P_(int) print, P_(int) loop_nb)
{  do_save = saving;
   do_print = print;
   var_position = 0;
	if (loop_nb == 0) mode_codes = (int *) tst_alloc(n_var, sizeof(int), "var_alloc_check");
   }
void var_end_loop(void)
{   free(mode_codes);
    }
/* ------------------------------------------------------------------ */
char *var_set_name( P_(TYPE_VAR *) var, P_(char *) name)
#ifdef NO_PROTO
VAR * var;
int arg;
#endif
{   if (var && name) var->nature = name;
    if (var) return var->nature; else return NULL;
	 }
/* ------------------------------------------------------------------ */
void * var_get_link (P_(TYPE_VAR) * var)
{  return var->link;
   }
/* ------------------------------------------------------------------ */
TYPE_VAR * fget_var ( P_(int) nombre, P_(int)  ncle, P_(int)  arg,
	  P_(char *) nature, P_(void **) cle, P_(char *) keyname, 
	  P_(int *) nb_ptr, P_(int) mode, P_(float) allow_shift)
#ifdef NO_PROTO
int nombre;         /* number of element to be read */
int ncle;           /* 0 or repeting width for legend  */
int arg;            /* according constants VAR_ from xnd_t_var.h */
char *nature;       /* global identifier in listing */          
void **cle;         /* identifiers of elements */
char *keyname;      /* key identifier */
int * nb_ptr;       /* pointer to the number of elements */
int mode;
float allow_shift;
#endif
{  TYPE_VAR *var;
   float *v,*s;
   int *c,*p;
   int  i,j,h,k;
   float *p_float;
   sint *p_hkl;
   int  ok;
   char *key;
   int  n_var0 = n_var;
	  
   push_err_msg("fget_var(xnd_vio.c)");
	var = (TYPE_VAR *) tst_alloc(1,sizeof(TYPE_VAR),"variable");
   memset(var, 0, sizeof(TYPE_VAR));
   var->remark = read_remark(NULL);
   var->number = nombre;
   var->argtype = arg;
   var->nature = nature;
   var->cle = cle;
   if (nombre==0)
   {  fprintf(list_fich," %s : ignored\n", nature);
	   pop_err_msg();
		return var;
	   }
   if (ncle==0) ncle=nombre;
   var->ncle = ncle;
   var_order = VAR_ORDER;
   var_dim   = VAR_DIM;
   var_number = nombre;
/*	var->relax = 0;*/
   key = ( keyname==NULL) ?  nature : keyname;
	if ( get_keys( key, NULL, 
          "ORDER", KEYTYPE_INT, &var_order, var_order,
          "SIZE",  KEYTYPE_INT, &var_dim, var_dim,
          "NUMBER",  KEYTYPE_INT, &var_number, var_number,
          "MODE",   KEYTYPE_INT, &(var->mode), mode & var_mode_mask,
          "RELAX",  KEYTYPE_FLOAT, &(var->relax), &(var->relax),
          "SHIFT",  KEYTYPE_FLOAT, &(var->allow_shift), &allow_shift,
          NULL ) == -1 )
   {  j=fscanf (coord_fich,"%d",&var_order);
	   tst_abort ((j==0), " No keys, Expansion order not found, reading parameters %s\n", nature);
      if (var_order<0)
      {  var_order = -var_order;
         fscanf (coord_fich,"%d",&var_dim);
	      } else var_dim=1;
      }
   fprintf(list_fich," %s : %d parameters : expansion order %d (size %d)\n",
	   arg==VAR_ATOM?"COORD":nature, nombre, var_order, var_dim);
   var->dim  = var_dim;
   var->order = var_order;
   var->number = var_number;
   if (var->number != nombre)
	{  tst_abort( nb_ptr==NULL, 
	    "The number of components cannot be changed in this variable!");
      *nb_ptr = nombre = var->number;
		}
   if (var->relax) fprintf(list_fich," relaxation coef is multiplied by %f for this var \n", var->relax);
   if ( var->allow_shift == 0 &&  var->mode & VAR_MODE_ABS) var->mode &= ~VAR_MODE_ABS;
	if (var->mode) 
	{   fprintf(list_fich," boundaries set (%d) for %s", var->mode,  var->mode & VAR_MODE_GT0 ? "'var>0'":"");
		 if ( var->mode & VAR_MODE_ABS) fprintf(list_fich," '|shift| < %f'", var->allow_shift);
		 fprintf(list_fich,"\n");
		 }
	switch (arg)
   {  case VAR_FLOAT : p_float = (float *) tst_alloc (nombre,sizeof(float),nature); 
			var->link = p_float;
		   break;
	   case VAR_HKL : p_hkl = (sint *) tst_alloc(nombre, l_phase->hkl_size*sizeof(sint),"hkl");
			var->link = p_hkl;
		   if (var_order==0)
		   {	tst_abort((l_phase->n_atom==0),"n_atom=var_orderhkl=0");
			   for (j=0; j<nombre; j++,p_hkl+=l_phase->hkl_size)
			   {  fprintf (list_fich, "%3d HKL",j);
               k = 0;
               for (i=0;i<l_phase->hkl_size;i++)
               {  tst_abort( (fscanf (coord_fich,"%d",&h) != 1),"H[%d] not found", i);
                  p_hkl[i] = h;
				      fprintf (list_fich, " %3d",h);
                  k += (h>=0) ? h : -h;
                  }
				   fprintf (list_fich, "\n");
               tst_abort( (k==0), "HKL is node (0,0,0...)");
				   }
			   fprintf (list_fich," hkl lus\n");
		      }
		   break;
	  	  };

     if (var_order==0)  return var;
     tst_abort ((var_order>lect->max_ordre),E_READ,"max_order",(float)lect->max_ordre);
     var_realloc_table(var, 0);
     v= var->value; s= var->shift; c= var->codelu; p = var->param;
     for (i=0;i<nombre;i++)
     {   switch (arg)
	 {    case VAR_FLOAT :
		fscanf (coord_fich,"%f", p_float);
		fprintf(list_fich," %d_%8.3f", i/ncle, *p_float);
		p_float++;   break;
/*              case VAR_RADIAL :
		fscanf (coord_fich,"%f", p_float);
		fprintf(list_fich," %8.3f", *p_float);
		p_float++;   break;
*/	      case VAR_STD :
	      case VAR_ATOM :   /* coord atomiques */
		fprintf(list_fich," %8s", cle[i%ncle]);
		break;
	      case VAR_ORIEN :  /* profil,  orientation */
		fprintf(list_fich," %2d_%5s",i/ncle,cle[i%ncle]);
		break;
	      case VAR_HKL :  /* hkl intensities */
			   fprintf (list_fich, "%3d HKL",i);
            k = 0;
            for (j=0;j<l_phase->hkl_size;j++)
            {  tst_abort( (fscanf (coord_fich,"%d",&h) != 1),"H[%d] not found", j);
               p_hkl[j] = h;
               fprintf (list_fich, " %3d",h);
               k += (h>=0) ? h : -h;
               }
            tst_abort( (k==0), "HKL is node (0,0,0...)");
		      p_hkl+=l_phase->hkl_size;
		      break;
	      case VAR_POLY :  /* polynome */
		fprintf(list_fich," %2d_%2d",i/ncle,i%ncle);
		break;
		  };
	 var_init(var);
	 for (var_io=0;var_io<var_order;(var_io++,v++))
	 {   fscanf (coord_fich,"%f",v);
	     fprintf(list_fich," %12.6g",*v);
	     for (var_id=0;var_id<var_dim;(var_id++,s++,p++,c++))
 	 {   fscanf (coord_fich,"%d",c);
	     fprintf(list_fich," %3d",*c);
	     *p= 0;
	     if (*c != 0)
	     {   if (valid_ref<=1) ok = ( *c > 0 );
		 else ok = (*c==1 || (*c>=10 && *c<200)
	   || (*c > 0 && *c <10 &&(((*c - 2) % valid_ref) == lect->valid_reste))
	   || (*c > 200 && (((*c / 100 - 2) % valid_ref) == lect->valid_reste)));
		 if (ok > 0 ) n_var++;
		 if (ok && *c >= 10)
		 {   tst_abort((*c>=MAX_COD),"codeword to high");
		     fscanf (coord_fich,"%f",s);
		     if (lect->codepar[*c]==0) lect->codepar[*c]= ++n_par;
		     *p = lect->codepar[*c];
		     }
		 else
		 if (*c <= -10 || *c >= 100)
		 {   fscanf (coord_fich,"%f",s);
		     }
		 else
		 {   *s =1;
		     if (ok) *p = ++n_par;
		     };
		 fprintf(list_fich," (%3d %9.6f)",*p,*s);
		 }
		else fprintf(list_fich," (             )");
		if ( ( var_id % 4 == 3) && ( var_id+1-var_dim != 0 )) fprintf (list_fich,"\n %8s %12s", "","");
                }; /* for id */
 	    if ( (var_dim != 1 || ( var_io % 4 == 3 )) && ( var_io+1-var_order != 0) ) fprintf (list_fich,"\n %8s", "");
            };	/* for var_io */ 
           if ( (var_dim==1 && var_order==1 &&  (i %2))  || var_order>1 || var_dim != 1 )  fprintf(list_fich,"\n"); 
	 };
	if (var_order==1 && (i%2) ) fprintf(list_fich,"\n");
	fprintf(list_fich,"\n");
	fflush (list_fich);
	var->npar = n_var-n_var0;
	pop_err_msg();
   return var;
   }
/* -------------------------------------------------------------------- */
void fnew_var ( P_(TYPE_VAR *) var, P_(char *) keyname)
#ifdef NO_PROTO
TYPE_VAR * var;
int arg;
#endif
{   int  i,j, ij;
    float *v,*s;
    int *c;

     float *p_float;
     sint *p_hkl;
     int  ligne;
     char *key;
     
     if ( var==NULL ) return;
     write_remark (var->remark);

     if (var->number == 0) return;
     var_init(var);
     key = ( keyname==NULL) ?  var->nature : keyname;
     if ( new_keys ( key, 
        "ORDER", KEYTYPE_INT, VAR_ORDER_KEYMODE, var_order, (int) VAR_ORDER,
        "SIZE",  KEYTYPE_INT, VAR_DIM_KEYMODE,   var_dim,   (int) VAR_DIM,
         NULL ) == -1 )
   {  if (var_dim==1) fprintf(new_fich,"\n %d", var_order);
        else fprintf(new_fich,"\n -%d %d", var_order, var_dim);
	   }
     ligne = ((var_dim == 1) && (var_order == 1)) ? 2 : 1;
     switch (var->argtype)
     {   case VAR_FLOAT  : p_float = var->link;
		       break;
	      case VAR_HKL : p_hkl = (sint *) var->link;
		     if (var_order==0 && l_phase->n_atom!=0)
		     for (j=0;j<current_sets->nb_hkl;j++,p_hkl+=l_phase->hkl_size)
		     {  fprintf (new_fich,"\n ");
		        for(ij=0;ij<l_phase->hkl_size;ij++) fprintf (new_fich,"%3d ", p_hkl[ij]);
				  }
             break;
/*	   case VAR_RADIAL : p_float = l_radial->diff_pos;
*/		break;
	  }
     if (ligne == 3 && (var->ncle == 2 || var->ncle==4)) ligne = 2;
     v = current_var->value;
     s = current_var->shift;
     c = current_var->codelu;
    if (var_order==0) return;
    for (i=0;i<var->number;i++)
     {       switch (var->argtype)
     {    case VAR_FLOAT :
/*	       case VAR_RADIAL :
*/		fprintf (new_fich,"%s %8.3f   ", i ?"\n":"", *p_float ); p_float++;
		break;
/**/	      case VAR_HKL : fprintf (new_fich,"%s ", i ?"\n":"");
		       for(ij=0;ij<l_phase->hkl_size;ij++) fprintf (new_fich,"%3d ", p_hkl[ij]);
             p_hkl+=l_phase->hkl_size; 
				 break;
	  default :  if (i) fprintf(new_fich,"%s", (i%ligne==0)?"\n":"  ");
	  }
	 for (var_io=0;var_io<var_order;(var_io++,v++))
	 {   fprintf(new_fich,"  %15.8g",*v);
	     for (var_id=0;var_id<var_dim;(var_id++,c++,s++))
	     {   if (var->argtype == VAR_HKL && *v < 0  && *c > 0 && var_io == 0 ) *c = - *c;
		 fprintf(new_fich," %3d",*c);
		 if (*c >= 10 || *c <= -10) fprintf(new_fich," %8f",*s);
		 else fprintf(new_fich,"         ");
		 };
	     if (var_order > 2 && var_io % 3 == 2 ) fprintf(new_fich,"\n           ");
	     };	 
	 if (var_order > 2 && var_io % 3 != 2 ) fprintf(new_fich,"\n");
         };
         fprintf(new_fich,"\n");
     }

/* ------------------------------------------------------------------ */
/*  test if a parameter shift has to be restricted to handle non-linear behaviour  */
int  var_check ( P_(TYPE_VAR *) var)
#ifdef NO_PROTO
VAR *var;
#endif
{    int   i,n,m,mm,ij;
     int   premier = 0;
     float valeur, shift, deplac, sval, dval;
     float sigma2, sigma, signif;
     int over_range = 0;
     if ( var==NULL || var->number ==0 || var->npar ==0) return 0;
     push_err_msg ("var_check");
     var_init (var);
     for (i=0;i<var->number;i++)
     {   for (var_io=0;var_io<var_order;var_io++)
     {   deplac = sigma2 = 0;
         m = mm = 0;
         for (var_id=0;var_id<var_dim;var_id++)
         if ((n=var_param(i))!=0)
         {   shift = var_shift();
             dval =  y_vect[n-1];
             /*sval =  matrice[(n*(n+1))/2-1];  */
             deplac += shift * dval;
             /*sigma2  += shift * shift * val_sigma * sval; */
             if (m) mm=1;
             m += n;
             }
         if (m)
         {   int code;
             float allowed = var_allowed(deplac, &code);
			    if (code)
             {  over_range++;
                mode_codes[var_position] |= code;
                for (var_id=0;var_id<var_dim;var_id++)
                if ((n=var_param(i))!=0) y_vect[n-1] *= allowed;
                }
             var_position++;
           } /* if (m) */
         } /* for var_io */
      }
    pop_err_msg();
	 return over_range;
    }
/* -------------------------------------------------------------------- */
static void printformat  PROTO(( float a, float b, float c, float signif ));
/* ------------------------------------------------------------------ */
/*    meme definition des cas que dans xnd_rvar.c VAR cf xnd_def.h    */
int  var_fput ( P_(TYPE_VAR *) var)
#ifdef NO_PROTO
VAR *var;
#endif
{  int   i,n,m,mm,ij,fixe;
   int   premier = 0;
   float valeur, shift, deplac, sval, dval;
   float sigma2, sigma, signif;
   sint *p_hkl;
   float *p_float;
   char **cle;
   int ncle;

   if ( var==NULL || var->number ==0 || var->npar ==0) return 0;
   push_err_msg ("fput_var");
   switch (var->argtype)
   {  case VAR_FLOAT     : p_float = var->link;          break;
      case VAR_HKL    : p_hkl   = (sint *) var->link; break;
/*      case VAR_RADIAL : p_float = l_radial->diff_pos; break;
*/      }
   ncle=var->ncle;
   cle = (char**) var->cle;
   var_init (var);
   for (i=0;i<var->number;i++)
   {  for (var_io=0;var_io<var_order;var_io++)
      {  deplac = sigma2 = 0;
           m = mm = fixe = 0;
           for (var_id=0;var_id<var_dim;var_id++)
           if ((n=var_param(i))!=0)
           {  shift = var_shift();
              dval =  y_vect[n-1];
              sval =     matrice[(n*(n+1))/2-1];
              deplac += shift * dval;
              sigma2  += shift * shift * val_sigma * sval;
				  if (sval == 1 && dval == 0) fixe++;
              if (m) mm=1;
              m += n;
              }
         if (m)
			{   /*  verbose_printf("  %3d dval %f sval %f\n", var_position, dval, sval); */
   if( !(fixe && deplac==0))
         {   if (do_print)
         {   if (mm==0) fprintf(list_fich," %3d",m);
             fprintf(list_fich,"%s  %8s",mm==0?"":"   *",
                            (premier++==0)?var->nature:"");
             switch (var->argtype)
         {   case VAR_FLOAT     : 
                       fprintf(list_fich,"%d_%7.3f",i/ncle,p_float[i]);
                       break;
/*         case VAR_RADIAL :
                       fprintf(list_fich," %8.3f",p_float[i]);   
                       break;
*/         case VAR_STD    : 
         case VAR_ATOM   :
                       fprintf(list_fich," %8s",cle[i%ncle]);
                       break;
         case VAR_ORIEN  : 
                       fprintf(list_fich," %2d_%5s",i/ncle,cle[i%ncle]);
                       break;
         case VAR_HKL    :
		                 if (l_phase->hkl_size==4)fprintf (list_fich," ");
							  for(ij=0;ij<l_phase->hkl_size;ij++)
                         fprintf (list_fich,"%*d", l_phase->hkl_size==3?3:2, p_hkl[ij+i*l_phase->hkl_size]);
                       break;
         case VAR_POLY  :
                       fprintf(list_fich," %2d_%2d",i/ncle,i%ncle);
                       break;
         }
            sigma = sqrt(fabs(sigma2));
              valeur = var_new(&deplac);
                signif = eps_stop*sigma;
            fprintf(list_fich," (%d) ", var_io);
/*  fprintf(list_fich," (%d) %12.6g %9.3g %9.3g\n",var_io,var_new(deplac),deplac,sigma); */
                printformat (valeur, deplac, sigma, signif);
            if (fabs(deplac)>signif)  { fini=0; fprintf(list_fich,"  "); }
            else   fprintf(list_fich," *");
            if ( fixe ) fprintf(list_fich, " NOT");
            if ( mode_codes[var_position] & VAR_MODE_GT0 ) fprintf(list_fich, " GT0");
            if ( mode_codes[var_position] & VAR_MODE_ABS ) fprintf(list_fich, " ABS");
            if (sigma2 < 0) fprintf(list_fich," error, sigma2(%.2g)<0", sigma2);
            fprintf(list_fich,"\n");
				if (prt_cif && prt_cif != -1) fprintf(cif_fich,"%3d %8s %2d %f %f\n", 
				   m, var->nature, i, valeur, sigma);
           }  /* do_print */
          else
          {   var_new(&deplac); 
/*              if (fabs(deplac)>eps_stop*sigma)  fini=0;     */
              } }
           var_position++;
           } /* if (m) */
         } /* for var_io */
      }
    pop_err_msg();
	 return 0;
      }
/* ------------------------------------------------------------------ */
/* this procedure allows a common format for its parameters */

#define TOT_DIGITS 11
#define MIN_PRINT  (1.0E6*MINFLOAT)
static void printformat  ( P_(float) a, P_(float) b, P_(float) c, P_(float) signif )
#ifdef NO_PROTO
float a, b, c;
float signif;
#endif
{
    int range;
    int value;
    int lga;
    int level=0;
    int digits;
     int tot;
    float shift;
    char  msg[20];

    push_err_msg("printformat(xnd_vio.c)");
    if ( signif > MIN_PRINT ) range = floor (log10 (signif) - 1);
    else
    {    range = 0;
         fprintf(list_fich, "  XND_ERROR printformat : signif(%g) <~ 0 %g %g %g\n", signif, a, b, c);
        }
    lga =  (fabs(a) > MIN_PRINT ) ? floor(log10(fabs(a))) : floor(log10(MIN_PRINT));



/*fprintf(list_fich,"\n\n range %d  lga %d level    shift   , a %g\n", range,lga,a); */
    if ( ( lga < 0 && range < -TOT_DIGITS )  || ( lga > 0 && range > 0 ) )
    {   level = lga;
        shift = pow((double)10.0, (double) level);
        a /= shift;
    b /= shift;
    c /= shift;
        range -=lga;
    lga -= lga;
        }
    value =  lga > 2-TOT_DIGITS ? lga:  2-TOT_DIGITS;
    digits = value - range;
    if (digits < 2)  { digits = 2; range = value - digits; } 


   if (lga > 0)  digits = ( digits > lga)  ?  digits - lga : 0 ; 
        else  if (lga != 0) digits -= lga;
   tot =  (digits <= TOT_DIGITS) ? TOT_DIGITS : digits;
   if ( tot > TOT_DIGITS )
       fprintf(list_fich,"debug info : range %d value %d digits %d lga %d level %d shift %g, a %g b %g c %g\n                          ", 
range,value,digits,lga,level, shift, a, b ,c);

   

   if (level ) sprintf (msg,"e%+03d" , level);  else strcpy(msg,"    ");
   fprintf (list_fich," % #*.*f%s % #*.*f%s % #*.*f%s  %5.2f",
       tot, digits, a, msg, tot, digits, c, msg, tot, digits, b, msg, b/c);

   pop_err_msg();
   }
/* -------------------------------------------------------------------- */
TYPE_VAR * var_alloc (int number, int arg)
{  TYPE_VAR *var;
   sint *p_hkl;
	int old;
   push_err_msg("var_alloc (xnd_vio.h)");
   tst_abort ((arg!=VAR_HKL), "Unexpected var_alloc arg");
   if (current_sets->intensity == NULL)
   {  var = (TYPE_VAR *) tst_alloc(1,sizeof(TYPE_VAR),"var_alloc");
      memset( var, 0,sizeof(TYPE_VAR));
      var->argtype = VAR_HKL;
      var->order = 1;
      var->dim   = 1;
      var->number = number;
      var->nature = "LINES";
      var_realloc_table(var, 0);
		var->mode = VAR_MODE_GT0 & var_mode_mask;
      p_hkl = (sint *) tst_alloc(number, sizeof(sint)*l_phase->hkl_size,"hkl");
      var->link = p_hkl;
		memset( p_hkl, 0, number*sizeof(sint)*l_phase->hkl_size);
		}
   else 
   {  var = current_sets->intensity;
      old= var->number;
      var->number = number;
      var_realloc_table(var, old);
      p_hkl = (sint *) realloc(var->link, number*sizeof(sint)*l_phase->hkl_size);
      memset( p_hkl+old*l_phase->hkl_size, 0, (number-old)*sizeof(sint)*l_phase->hkl_size);
      var->link = p_hkl;
      }
   current_sets->intensity = var;
   pop_err_msg();
   return var;
   }
/* ---------------------------------------------------------- */
void  var_set_value(TYPE_VAR *var, int pos, float fval)
{   float *val = var->value;
    val[pos] = fval;
    }
/* -------------------------------------------------------------------- */
int  var_par_set(TYPE_VAR *var, int b, int e, int c)
{  int p, n = 0;
   for (p=b; p<e && p <var->number; p++)
	{   var->codelu[p] = c;
       var->shift[p] = 1;
       var->param[p] = ++n + n_par ;
       var->npar++;
		 }
   return n;
	}
/* -------------------------------------------------------------------- */
void  var_adjust(TYPE_VAR *var, int number)
{   tst_abort((number>var->number)," error adjusting size");
    var->number = number;
    }
/* -------------------------------------------------------------------- */
void  var_init_mode( int mask)
{   var_mode_mask = ~ mask;
    }
/* -------------------------------------------------------------------- */
/* internal procedures */
/* -------------------------------------------------------------------- */
static void var_realloc_table(TYPE_VAR *var, int old)
{  int  clean, save, dclean, dsave;
   int  size =  var->order * var->number;
   int  dsize = var->dim * size;
   push_err_msg("var_realloc_table");
	if (old>var->number) old = 0;
   clean = var->order * (var->number-old);
   dclean = var->dim * clean;
	save = old *  var->order;
   dsave = var->dim * save;
   if (var->value == NULL)
   {   var->value = (float *) malloc (size*sizeof(float));
       memset(var->value,0,size*sizeof(float));
       } else
   {   var->value = (float *)realloc(var->value, size*sizeof(float));
       if (old) memset(var->value+save,0,clean*sizeof(float));
       }
   if (var->saved == NULL)
   {   var->saved = (float *) malloc (size*sizeof(float));
       memset(var->saved,0,size*sizeof(float));
       } else
   {   var->saved = (float *)realloc(var->saved, size*sizeof(float));
       if (old) memset(var->saved+save,0,clean*sizeof(float));
       }
   if (var->shift == NULL)
   {   var->shift = (float *) malloc (dsize*sizeof(float));
       memset(var->shift,0,dsize*sizeof(float));
       } else
   {   var->shift = (float *)realloc(var->shift, dsize*sizeof(float));
       if (old) memset(var->shift+dsave,0,dclean*sizeof(float));
       }
   if (var->codelu == NULL)
   {   var->codelu = (int *) malloc (dsize*sizeof(int));
       memset(var->codelu,0,dsize*sizeof(float));
       } else
   {   var->codelu = (int *)realloc(var->codelu, dsize*sizeof(int));
       if (old) memset(var->codelu+dsave,0,dclean*sizeof(int));
       }
   if (var->param == NULL)
   {   var->param = (int *) malloc (dsize*sizeof(int));
       memset(var->value,0,dsize*sizeof(float));
       } else
   {   var->param = (int *)realloc(var->param, dsize*sizeof(int));
       if (old) memset(var->param+dsave,0,dclean*sizeof(int));
       }
   tst_abort((var->value==NULL ||var->saved==NULL ||var->shift==NULL ||var->codelu==NULL||var->param==NULL),
      "(re)alloc) var %s (number %d)",var->nature, var->number);
   pop_err_msg();
	}
/* -------------------------------------------------------------------- */

