static char *cvs_id =" $Id: xnd_rad.c,v 1.2 2002/05/02 12:43:27 berar Exp $ ";
/* XND_RAD    simple radial distribution ...          */
/* simple model according D Simeone @saclay.cea.fr    */
/* using formulae 11-15 from  Klug and Alexander      */
/* I/N = Sigma(m) f(m)^2 + 4 pi  fe^2 Sum(0,inf)      */
/*          Sigma(m) K(m) deltaG(m,r)   r^2  sin(sr)/sr dr */
/* with N = scale                                     */
/* .................................................. */
#define  USE_BRAGG
#define  USE_VAR
#define  USE_SCAN
#define  USE_EXPER
#define  USE_PHASE
#define  USE_ATOM
#include "xnd_def.h"
#include "xnd_cah.h"
#include "xnd_mem.h"
/* ---------------------------------------------------------- */
void int_radist (P_(void))
{  float *coef, *d_coef, *dist;
	int   n, ip, ia, ic;
	int   nd, iod, i, j;
   int   calc_deriv;
	int   iprint=100;
   
   if (minli==0) fprintf(list_fich,"\n");
   if (n_pts > 20*iprint ) iprint *= 1+n_pts/(20*iprint);
   nd = l_phase->nb_dist;
	coef = (float *) tst_alloc (nd, sizeof(float),"distrib");
   d_coef = (float *) tst_alloc (nd, sizeof(float),"distrib");
   dist = (float *) l_phase->radial->link;
   for (act->lambda=0;act->lambda<l_exper->n_lambda;act->lambda++)
	{  temp = &temp_exper;
	   var_init (l_onde);
		lambda = var_valeur (act->lambda*LAMBDA);
		exper_echelle = var_valeur (act->lambda*LAMBDA+1);
		echelle = phase_echelle * exper_echelle;
      temp = &temp_phase;
      var_init(l_phase->radial);
		for (ic=0; ic<nd;ic++) coef[ic]=var_valeur(ic);
      for (ip=0,l_points=l_diag->points;ip<n_pts;ip++,l_points++)
      {  float qq, ampli, ycal, fsum;
         sin_t = sin (0.5*RAD**l_points);   /* valcor */
         qq = 2 * M_PI * (s = 2 * sin_t / lambda);
         cos_t = sqrt (1-sin_t*sin_t);
         valcor ();
         fsum = 0;
         for (ia=0,l_atom=l_phase->atom;ia<l_phase->n_atom;ia++,l_atom++)
         {  float occ, f;
            int nb = l_atom->nb;
            var_init(l_atom->x);
            occ = var_valeur (0);
            f = (*valdif)();
            if (dif_nature == EXPER_RXA)  fsum += occ * sqr(f+anodif()) + sqr(anodif_b());
            else  fsum += occ * sqr(f);
            }
			ampli=0;
			for (n=0;n<nd;n++)
			{  float bqq = qq*dist[n];
				d_coef[n] = (bqq > EPSILON) ? sin(bqq)/bqq : 0;
				ampli += coef[n] * d_coef[n]; 
				}  
			ycal= echelle * fsum * ( 1 + ampli ) * act->cor; 
			add_ical(ip, ycal); 
         if ( minli== 0 && ip % iprint == 0 )  fprintf(list_fich , 
           " radial_dist %3d  %7.3f %7.4f ->  %8f %8f\n",ip, *l_points, qq, ampli,ycal);     
         if (do_derivatives)
			{  if (var_ideriv(l_onde)) 
			   { 	 temp = &temp_exper;
		          VAR_io_id
		          i=act->lambda*LAMBDA+1;
		          if ((j=var_param(i))!=0)
		            add_dydp(ip, j, ycal / exper_echelle * var_derive());
		          temp = &temp_phase;
					 }
            if (var_ideriv(l_phase->ech)) 
			   { 	VAR_io_id  
                 if ((j=var_param(0))!=0)
		            add_dydp (ip, j, ycal * *(d_echelle) * var_derive());
               }
            if (var_ideriv(l_phase->transit)) 
		      {  VAR_io_id  for (i=0;i<var_number;i++)
		           if ((j=var_param(i))!=0)
		             add_dydp(ip, j,ycal * var_derive()* *(d_echelle+l_phase->ech->number+i));
					}
				if (var_ideriv(l_phase->radial))
	         {   VAR_io_id  for (i=0;i<nd;i++)
	               if ((j=var_param(i))!=0)
	                 add_dydp(ip, j, d_coef[i]  * fsum * echelle * act->cor * var_derive());
	              }
		      }
	 }   }
   free(coef);
   free(d_coef);
	}
/* ---------------------------------------------------------- */
